Object subclass: #Comparable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'cs655'!

!Comparable methodsFor: 'as yet unclassified' stamp: 'jjj 11/17/2011 22:42'!
< other
		"Is Current less than other?  Redefine in descendants"
	(other isMemberOf: (self class)) ifFalse: [^self error: 'other like Current'].
	^nil		"must be redefined"! !

!Comparable methodsFor: 'as yet unclassified' stamp: 'jjj 11/17/2011 22:28'!
<= other
		"Is Current less than or equal to other? "
	(other isMemberOf: (self class)) ifFalse: [^self error: 'other like Current'].
	^((other < self) not)! !

!Comparable methodsFor: 'as yet unclassified' stamp: 'jjj 11/17/2011 22:30'!
= other
		"Is Current equal to other? "
	(other isMemberOf: (self class)) ifFalse: [^self error: 'other like Current'].
	^(((self < other) not) & ((other < self) not))! !

!Comparable methodsFor: 'as yet unclassified' stamp: 'jjj 11/17/2011 22:26'!
> other
		"Is Current greater than other?  "
	(other isMemberOf: (self class)) ifFalse: [^self error: 'other like Current'].
	^(other < self)! !

!Comparable methodsFor: 'as yet unclassified' stamp: 'jjj 11/17/2011 22:28'!
>= other
		"Is Current greater than or equal to other? "
	(other isMemberOf: (self class)) ifFalse: [^self error: 'other like Current'].
	^((self < other) not)! !


Object subclass: #Constants
	instanceVariableNames: ''
	classVariableNames: 'Conversions'
	poolDictionaries: ''
	category: 'cs655'!


!Constants methodsFor: 'constants - Temperature' stamp: 'jjj 11/16/2011 22:17'!
celcius
	^Unit new make: 'Celcius' Type: self temperature! !

!Constants methodsFor: 'constants - Temperature' stamp: 'jjj 11/16/2011 22:17'!
fahrenheit
	^Unit new make: 'Fahrenheit' Type: self temperature! !

!Constants methodsFor: 'constants - Temperature' stamp: 'jjj 11/16/2011 18:08'!
kelvin
	^Unit new make: 'kelvin' Type: self temperature! !


!Constants methodsFor: 'constants - mass' stamp: 'jjj 11/16/2011 18:09'!
gram
	^Unit new make: 'grams' Type: self mass! !

!Constants methodsFor: 'constants - mass' stamp: 'jjj 11/16/2011 18:09'!
kilogram
	^Unit new make: 'kilograms' Type: self mass! !

!Constants methodsFor: 'constants - mass' stamp: 'jjj 11/16/2011 18:09'!
pound
	^Unit new make: 'pounds' Type: self mass! !


!Constants methodsFor: 'constants - time' stamp: 'jjj 11/16/2011 18:09'!
day
	^Unit new make: 'days' Type: self time! !

!Constants methodsFor: 'constants - time' stamp: 'jjj 11/16/2011 18:09'!
hour
	^Unit new make: 'hours' Type: self time! !

!Constants methodsFor: 'constants - time' stamp: 'jjj 11/16/2011 18:09'!
minute
	^Unit new make: 'minutes' Type: self time! !

!Constants methodsFor: 'constants - time' stamp: 'jjj 11/16/2011 18:09'!
second
	^Unit new make: 'seconds' Type: self time! !


!Constants methodsFor: 'constants - length' stamp: 'jjj 11/16/2011 18:07'!
centimeter
	^Unit new make: 'centimeters' Type: self length! !

!Constants methodsFor: 'constants - length' stamp: 'jjj 11/16/2011 18:09'!
foot
	^Unit new make: 'feet' Type: self length! !

!Constants methodsFor: 'constants - length' stamp: 'jjj 11/16/2011 18:09'!
inch
	^Unit new make: 'inches' Type: self length! !

!Constants methodsFor: 'constants - length' stamp: 'jjj 11/16/2011 18:10'!
kilometer
	^Unit new make: 'kilometers' Type: self length! !

!Constants methodsFor: 'constants - length' stamp: 'jjj 11/16/2011 18:10'!
meter
	^Unit new make: 'meters' Type: self length! !

!Constants methodsFor: 'constants - length' stamp: 'jjj 11/16/2011 18:10'!
mile
	^Unit new make: 'miles' Type: self length! !

!Constants methodsFor: 'constants - length' stamp: 'jjj 11/16/2011 18:10'!
yard
	^Unit new make: 'yards' Type: self length! !


!Constants methodsFor: 'dimensions' stamp: 'jjj 11/13/2011 22:11'!
amount
	^7! !

!Constants methodsFor: 'dimensions' stamp: 'jjj 11/13/2011 22:12'!
current
	^4! !

!Constants methodsFor: 'dimensions' stamp: 'jjj 11/13/2011 22:12'!
intensity
	^6! !

!Constants methodsFor: 'dimensions' stamp: 'jjj 11/13/2011 22:12'!
length
	^1! !

!Constants methodsFor: 'dimensions' stamp: 'jjj 11/13/2011 22:12'!
mass
	^2! !

!Constants methodsFor: 'dimensions' stamp: 'jjj 11/13/2011 22:13'!
temperature
	^5! !

!Constants methodsFor: 'dimensions' stamp: 'jjj 11/13/2011 22:13'!
time
	^3! !


!Constants methodsFor: 'initialize-release' stamp: 'jjj 11/17/2011 19:35'!
initConversions
	"Add conversion functions (blocks) to the table."	
	| kelvinConst celciusFact freezing |
"	(Conversions = nil) ifTrue: [
"		Conversions := Dictionary new.    ";yourself. "

		kelvinConst := (Rational new setN: 272 D: 1) + (Rational new setN: 15 D: 100).
		celciusFact := Rational new setN: 9 D: 5.
		freezing := Rational new setN: 32 D: 1.
			"Perhaps a better way to store these conversions would be a graph.  The result of a
			shortest-path search could give a path of conversions that would go from the source 
			unit to the destination unit.  But, since there is no predefined graph class..."
		Conversions at: (self foot name, self meter name) put: [ :aRat | aRat * (Rational new setN: 3048 D: 10000)].
		Conversions at: (self meter name, self foot name) put: [ :aRat | aRat * (Rational new setN: 10000 D: 3048)].
		Conversions at: (self meter name, self kilometer name) put: [ :aRat | aRat * (Rational new setN: 1  D: 1000)].
		Conversions at: (self kilometer name, self meter name) put: [ :aRat | aRat * (Rational new setN: 1000  D: 1)].
		Conversions at: (self foot name, self yard name) put: [ :aRat | aRat * (Rational new setN: 1 D: 3)].
		Conversions at: (self yard name, self foot name) put: [ :aRat | aRat * (Rational new setN: 3 D: 3)].
		Conversions at: (self foot name, self inch name) put: [ :aRat | aRat * (Rational new setN: 12 D: 1)].
		Conversions at: (self inch name, self foot name) put: [ :aRat | aRat * (Rational new setN: 1 D: 12)].
		Conversions at: (self yard name, self inch name) put: [ :aRat | aRat * (Rational new setN: 36 D: 1)].
		Conversions at: (self inch name, self yard name) put: [ :aRat | aRat * (Rational new setN: 1 D: 36)].
		Conversions at: (self foot name, self inch name) put: [ :aRat | aRat * (Rational new setN: 12 D: 1)].
		Conversions at: (self foot name, self mile name) put: [ :aRat | aRat * (Rational new setN: 1 D: 5280)].
		Conversions at: (self mile name, self foot name) put: [ :aRat | aRat * (Rational new setN: 5280 D: 1)].
		Conversions at: (self yard name, self mile name) put: [ :aRat | aRat * (Rational new setN: 1 D: 1760)].
		Conversions at: (self mile name, self yard name) put: [ :aRat | aRat * (Rational new setN: 1760 D: 1)].
			"The following 'goofy' conversion was added as a workaround to the deepCopy bug (see
			comment in Tester testConversions.)  Without this workaround, GST SmallTalk will give an
			erroneous exception."
		Conversions at: (self mile name, self meter name) put: [ :aRat | aRat * (Rational new setN: 1609 D: 1)].

		Conversions at: (self gram name, self kilogram name) put: [ :aRat | aRat * (Rational new setN: 1  D: 1000)].
		Conversions at: (self kilogram name, self gram name) put: [ :aRat | aRat * (Rational new setN: 1000  D: 1)].
		Conversions at: (self kilogram name, self pound name) put: [ :aRat | aRat * (Rational new setN: 2204  D: 1000)].		
		Conversions at: (self pound name, self kilogram name) put: [ :aRat | aRat * (Rational new setN: 1000  D: 2204)].

		Conversions at: (self second name, self minute name) put: [ :aRat | aRat * (Rational new setN: 1 D: 60)].
		Conversions at: (self minute name, self hour name) put: [ :aRat | aRat * (Rational new setN: 1 D: 60)].
		Conversions at: (self hour name, self day name) put: [ :aRat | aRat * (Rational new setN: 1 D: 24)].
		Conversions at: (self day name, self hour name) put: [ :aRat | aRat * (Rational new setN: 24 D: 1)].
		Conversions at: (self hour name, self minute name) put: [ :aRat | aRat * (Rational new setN: 60 D: 1)].
		Conversions at: (self minute name, self second name) put: [ :aRat | aRat * (Rational new setN: 60 D: 1)].
		Conversions at: (self second name, self hour name) put: [ :aRat | aRat * (Rational new setN: 1 D: (60 * 60))].
		Conversions at: (self hour name, self second name) put: [ :aRat | aRat * (Rational new setN: (60 * 60) D: 1)].

		Conversions at: (self celcius name, self kelvin name) put: [ :aRat | aRat + kelvinConst].
		Conversions at: (self kelvin name, self celcius name) put: [ :aRat | aRat - kelvinConst].
		Conversions at: (self celcius name, self fahrenheit name) put: [ :aRat | aRat * celciusFact + freezing ].
		Conversions at: (self fahrenheit name, self celcius name) put: [ :aRat | (aRat - freezing) * (celciusFact reciprocal) ].
		Conversions at: (self fahrenheit name, self kelvin name) put: 
			[ :aRat | (aRat - freezing) * (celciusFact reciprocal) + kelvinConst].
		
"	]
"! !

!Constants methodsFor: 'initialize-release' stamp: 'jjj 11/13/2011 22:26'!
initialize
	self make! !

!Constants methodsFor: 'initialize-release' stamp: 'jjj 11/14/2011 01:50'!
make
"	(IsInitialized = nil) ifTrue: [self initConversions]
	ifFalse: [self signal]
"	
	self initConversions.! !


!Constants methodsFor: 'query' stamp: 'jjj 11/16/2011 18:39'!
dimensionString: index
		"The string representation of the index-th dimension"
	(index >= self length) ifFalse: [^ self error: 'index large enough'].
	(index <= self amount) ifFalse: [^self error: 'index small enough'].
	(index = self length) ifTrue: [ ^'length' ].
	(index = self mass) ifTrue: [ ^'mass' ].
	(index = self time) ifTrue: [ ^'time' ].
	(index = self current) ifTrue: [ ^'current' ].	
	(index = self temperature) ifTrue: [ ^'temperature' ].	
	(index = self intensity) ifTrue: [ ^'intensity' ].
	(index = self amount) ifTrue: [ ^'amount' ].! !

!Constants methodsFor: 'query' stamp: 'jjj 11/14/2011 18:17'!
functionAt: aKey
	"Return the unit conversion function indexed by aKey"
	^(Conversions at: aKey)! !


Constants subclass: #Dimensionable
	instanceVariableNames: 'dimensionsImp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'cs655'!

!Dimensionable methodsFor: 'implementation' stamp: 'jjj 11/16/2011 17:26'!
denomCount
		"The number of negative exponents in dimensions table."
	| cnt |
	cnt := 0.
	self length to: self amount do:
		[:i | (dimensionsImp at: i) < 0 ifTrue: [cnt := cnt + 1]].
	^cnt! !

!Dimensionable methodsFor: 'implementation' stamp: 'jjj 11/16/2011 17:29'!
numerCount
		"The number of positive exponents in dimensions table."
	| cnt |
	cnt := 0.
	self length to: self amount do:
		[:i | (dimensionsImp at: i) > 0 ifTrue: [cnt := cnt + 1]].
	^cnt! !


!Dimensionable methodsFor: 'access' stamp: 'jjj 11/16/2011 17:28'!
dimensions
		"Get the dimensionsImp.  Should be selectively exported to objects like Current."
	^dimensionsImp! !


!Dimensionable methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 17:05'!
* other
		"Result of multiplying Current by other"
	^(self deepCopy multiply: other)! !

!Dimensionable methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 17:05'!
+ other
		"Result of adding other to Current"
	^(self deepCopy add: other)! !

!Dimensionable methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 17:06'!
- other
		"Result of subtracting other from Current"
	^(self deepCopy subtract: other)! !

!Dimensionable methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 17:06'!
/ other
		"Result of dividing Current by other"
	^(self deepCopy divide: other)! !

!Dimensionable methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 17:08'!
add: other
		"Add other to current.  (Does nothing except check precondition.)"
	(self isCommensurable: other) ifFalse: [^self error:  'other is not compatible with Current']! !

!Dimensionable methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 17:06'!
divide: other
		"Divide Current by other"
	self multiply: (other reciprocal)! !

!Dimensionable methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 17:07'!
invert
		"Invert Current -- dimensions in numerator move to denominator, etc."
	self length to: (self amount) do: [ :index |
		dimensionsImp at: index put: (dimensionsImp at: index) negated]! !

!Dimensionable methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 17:05'!
multiply: other
		"Multiply Current by other"
	self length to: self amount do: [ :index |
		dimensionsImp at: index put: ((dimensionsImp at: index) + (other dimensionAt: index))]
! !

!Dimensionable methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 17:34'!
negate
		"Negate Current (default does nothing)"! !

!Dimensionable methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 17:59'!
negated
		"The result of negating Current (This version returns a copy)"
	^(self deepCopy negate)! !

!Dimensionable methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 17:07'!
reciprocal
		"Result of inverting Current"
	^(self deepCopy invert)! !

!Dimensionable methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 18:01'!
subtract: other
		"Subtract other from Current."
	(self isCommensurable: other) ifFalse: [^self error:  'other is not compatible with Current'].
	^(self add: (other negated))! !


!Dimensionable methodsFor: 'printing' stamp: 'jjj 11/16/2011 18:39'!
printOn: aStream
	| nc dc cnt |
	nc := self numerCount.
	dc := self denomCount.
	cnt := 0.
	(nc > 1) ifTrue: [aStream nextPutAll: '('].
	(nc > 0) ifTrue:
		[self length to: self amount do: [:i | 
			(dimensionsImp at: i) > 0 ifTrue: 
				[cnt := cnt + 1.
				aStream nextPutAll: (self dimensionString: i).	
				(dimensionsImp at: i) > 1 ifTrue: [aStream 
					nextPutAll: '^';
					print: (dimensionsImp at: i)].
				(cnt < nc) ifTrue: [aStream nextPutAll: ' ']]]]
		ifFalse: [aStream print: 1].	
	(nc > 1) ifTrue: [aStream nextPutAll: ')'].
	(dc > 0) ifTrue: [aStream nextPutAll: '/'].
	(dc > 1) ifTrue: [aStream nextPutAll: '('].
	cnt := 0.
	self length to: self amount do: [:i |
		(dimensionsImp at: i) < 0 ifTrue:
			[cnt := cnt + 1.
			aStream nextPutAll: (self dimensionString: i).
			(dimensionsImp at: i) < -1 ifTrue: [aStream
				nextPutAll: '^';
				print: (dimensionsImp at: i) abs].
			(cnt < dc) ifTrue: [aStream nextPutAll: ' ']]].
	(dc > 1) ifTrue: [aStream nextPutAll: ')']! !


!Dimensionable methodsFor: 'query' stamp: 'jjj 11/16/2011 17:27'!
dimensionAt: index
		"The index-th dimension of Current"
	^(dimensionsImp at: index)! !

!Dimensionable methodsFor: 'query' stamp: 'jjj 11/16/2011 19:57'!
isCommensurable: other
		"Is other and Current compatible for addition and subtraction?"	
	self length to: self amount do: [ :index |
		(self dimensionAt: index) = (other dimensionAt: index) ifFalse: [ ^false ]].
	^true! !

!Dimensionable methodsFor: 'query' stamp: 'jjj 11/16/2011 19:47'!
isDimensionable
		"Is Current a Dimensionable?"
	^true! !


!Dimensionable methodsFor: 'initialize-release' stamp: 'jjj 11/17/2011 21:49'!
make
		"Create as dimensionless"
	dimensionsImp := Array new: (self amount).
	self length to: (self amount) do: [ :index | dimensionsImp at: index put: 0 ].
	! !

!Dimensionable methodsFor: 'initialize-release' stamp: 'jjj 11/16/2011 18:21'!
makeBasic: aDimension
		"Create with the one dimension (an integer between length and amount."
	(aDimension >= self length) ifFalse: [^ self error: 'aDimension large enough'].
	(aDimension <= self amount) ifFalse: [^self error: 'aDimension small enough'].
	self make.
	dimensionsImp at: aDimension put: 1.
	! !


Comparable subclass: #Rational
	instanceVariableNames: 'numerImp denomImp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'cs655'!

!Rational methodsFor: 'initialize-release' stamp: 'jjj 11/13/2011 20:45'!
initialize
	super initialize.
	self make.! !

!Rational methodsFor: 'initialize-release' stamp: 'jjj 11/13/2011 14:23'!
make
	numerImp := 0.
	denomImp := 1! !

!Rational methodsFor: 'initialize-release' stamp: 'jjj 11/11/2011 15:50'!
setN: aNum D: aDenom
	aDenom = 0 
		ifTrue: ['setNumerator:denominator: -- precondition, aDenom cannot be zero' signal]
		ifFalse:
			[numerImp := aNum asInteger.
			denomImp := aDenom asInteger abs.
			aDenom < 0
				ifTrue: [numerImp := numerImp negated].
			self reduce]! !


!Rational methodsFor: 'printing' stamp: 'jjj 11/11/2011 15:48'!
printOn: aStream
	|whole rem|
	(denomImp = 1) 
		ifTrue: [aStream print: numerImp]
		ifFalse: [(numerImp abs > denomImp)
			ifTrue: [whole := (numerImp / denomImp) asInteger.
					rem := numerImp abs \\ denomImp.
					aStream
						print: whole; space;
						print: (rem);
						nextPutAll: ('/');
						print: (denomImp)]
			ifFalse: [aStream
						print: (numerImp);
						nextPutAll: ('/');
						print: (denomImp)]]! !


!Rational methodsFor: 'access' stamp: 'jjj 11/11/2011 15:51'!
denominator
	"getter for denomImp"
	^denomImp! !

!Rational methodsFor: 'access' stamp: 'jjj 11/11/2011 15:51'!
numerator
	"getter for numerImp"
	^numerImp! !


!Rational methodsFor: 'status report' stamp: 'jjj 11/11/2011 16:54'!
isNegative
	"Is Current less than zero?"
	^(numerImp < 0)! !

!Rational methodsFor: 'status report' stamp: 'jjj 11/11/2011 16:53'!
isOne
	"Is Current equal to one?"
	^(numerImp = denomImp)! !

!Rational methodsFor: 'status report' stamp: 'jjj 11/11/2011 15:36'!
isRational
	"Always true for a Current of type Rational"
	^true! !

!Rational methodsFor: 'status report' stamp: 'jjj 11/11/2011 16:59'!
isReduced
	"Is Current in simplest terms?"
	^((numerImp gcd: denomImp) = 1)! !

!Rational methodsFor: 'status report' stamp: 'jjj 11/11/2011 16:52'!
isZero
	"Is Current equal to zero?"
	^(numerImp = 0)! !


!Rational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 19:09'!
* other
		"The result of Mulitplying Current by other"
	^(self deepCopy multiply: other)! !

!Rational methodsFor: 'basic operations' stamp: 'jjj 11/17/2011 19:34'!
+ other
		"Result of adding other to Current"
	^(self deepCopy add: other). ! !

!Rational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 19:13'!
- other
		"Result of subtracting other from Current"
	^(self deepCopy subtract: other)! !

!Rational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 19:13'!
/ other
		"Result of dividing Current by other"
	^(self deepCopy divide: other)! !

!Rational methodsFor: 'basic operations' stamp: 'jjj 11/17/2011 22:48'!
< other
		"Is Current less than other?"
	super < other.	"to check precondition"
	^((numerImp * other denominator) < (other numerator * denomImp))! !

!Rational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 21:47'!
add: other
	"Add other Rational to Current"
        "This code is addapted from the boost C++ library (www.boost.org)
         This calculation avoids overflow, and minimises the number of expensive
         calculations. Thanks to Nickolay Mladenov for this algorithm.
             Proof:
             We have to compute a/b + c/d, where gcd(a,b)=1 and gcd(b,c)=1.
	    Let g = gcd(b,d), and b = b1*g, d=d1*g. Then gcd(b1,d1)=1
	    
	    The result is (a*d1 + c*b1) / (b1*d1*g).
	    Now we have to normalize this ratio.
	    Let's assume h | gcd((a*d1 + c*b1), (b1*d1*g)), and h > 1
	    If h | b1 then gcd(h,d1)=1 and hence h|(a*d1+c*b1) => h|a.
	    But since gcd(a,b1)=1 we have h=1.
	    Similarly h|d1 leads to h=1.
	    So we have that h | gcd((a*d1 + c*b1) , (b1*d1*g)) => h|g
	    Finally we have gcd((a*d1 + c*b1), (b1*d1*g)) = gcd((a*d1 + c*b1), g)
	    Which proves that instead of normalizing the result, it is better to
	    divide num and den by gcd((a*d1 + c*b1), g)"
	|g d n|
	g := denomImp gcd: other denominator.
	d := denomImp // g.
	n := numerImp * ((other denominator) // g) + ((other numerator) * d).
	g := n gcd: g.
	n := n // g.
	d := d * ((other denominator) // g).
	self setN: n D: d
! !

!Rational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 21:45'!
divide: other
		"Divide Current by other"
	self multiply: (other reciprocal)! !

!Rational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 19:14'!
invert
		"Transform Current into its reciprocal"
	|n|
	n := numerImp.
	numerImp := denomImp.
	denomImp := n.
	(denomImp < 0) ifTrue:
		[numerImp = numerImp negated.
		denomImp = denomImp negated]! !

!Rational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 21:48'!
multiply: other
		"Muliply Current by other"
	| d1 d2 n d |
	d1 := numerImp gcd: (other denominator).
	d2 := (other numerator) gcd: denomImp.
	n := (numerImp // d1) * (other numerator // d2).
	d := (denomImp // d2) * (other denominator // d1).
	self setN: n D: d
! !

!Rational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 20:15'!
negate
		"Negate Current"
	numerImp := numerImp negated! !

!Rational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 17:59'!
negated
		"Result of negating Current"
	^(self deepCopy negate)
! !

!Rational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 19:15'!
reciprocal
		"The result of inverting Current"
	^(self deepCopy invert) ! !

!Rational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 19:16'!
reduce
		"Put Current into lowest terms."
	|d|
	numerImp = 0
		ifTrue: [denomImp := 1]
		ifFalse:
			[d := numerImp gcd: denomImp abs.		"to keep any negative in numerator"
			(numerImp \\ d) = 0 ifFalse: ['Rational.reduce--check no_numer_remainder'].
			(denomImp \\ d) = 0 ifFalse: ['Rational.reduce--check no_denom_remainder']. 
			numerImp := numerImp // d.
			denomImp := denomImp // d.]! !

!Rational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 21:48'!
subtract: other
		"Subtract other from Current"
	self add: (other negated).
	! !


Rational subclass: #DimensionedRational
	instanceVariableNames: 'unitsImp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'cs655'!

!DimensionedRational methodsFor: 'basic operations' stamp: 'jjj 11/17/2011 23:05'!
< other
		"Is Current less than other?"
	(self units isCommensurable: other) ifFalse: [^self error:  'other is not compatible with Current'].
	^(super < (other converted: self))
! !

!DimensionedRational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 20:51'!
add: other
		"Add other to Current"
	super add: (other converted: self).
	unitsImp add: other! !

!DimensionedRational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 19:51'!
convert: other
		"Convert Current to the same units as other"
	| cons r u ou dim fn |
	cons := Constants new.
	r := (Rational new) setN: numerImp D: denomImp. 
	cons length to: cons amount do: [ :index |
		u := self unitAt: index.
		ou := other unitAt: index.
		( (u ~= nil) & (ou ~= nil)) ifTrue:
			[(u name ~= ou name) ifTrue:  
				[dim := self dimensionAt: index.
				(dim >= 1) ifTrue: [ fn := cons functionAt: (u name, ou name)]
							ifFalse: [fn := cons functionAt: (ou name, u name)].
				1 to: (dim abs) do: 
					[ :dummy |
					r := fn value: r]]]].
	numerImp := r numerator.
	denomImp := r denominator.
	unitsImp convert: (other units)! !

!DimensionedRational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 19:48'!
converted: other
		"Make current have same *units* as other"
	^(self deepCopy convert: other)! !

!DimensionedRational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 21:50'!
invert
		"Transform Current into its reciprocal"
	super invert.
	unitsImp invert! !

!DimensionedRational methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 21:49'!
multiply: other
		"Muliply Current by other"
	super multiply: (other converted: self).
	unitsImp multiply: (other converted: self)
! !


!DimensionedRational methodsFor: 'initialize-release' stamp: 'jjj 11/16/2011 19:10'!
make
	super make.
	unitsImp := Unitable new make.! !

!DimensionedRational methodsFor: 'initialize-release' stamp: 'jjj 11/16/2011 18:59'!
makeBasic: aUnit
		"Initialize Current to value of one, with units equal to aUnit"
	unitsImp := Unitable new makeBasic: aUnit.
	self setN: 1 D:1.! !


!DimensionedRational methodsFor: 'query' stamp: 'jjj 11/16/2011 19:58'!
dimensionAt: index
		"the i-th dimension of Current"
	^(unitsImp dimensionAt: index)! !

!DimensionedRational methodsFor: 'query' stamp: 'jjj 11/16/2011 19:49'!
unitAt: index
		"the i-th unit of Current's dimension"
	^(unitsImp unitAt: index)! !


!DimensionedRational methodsFor: 'printing' stamp: 'jjj 11/16/2011 19:07'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' '.
	unitsImp printOn: aStream
! !


!DimensionedRational methodsFor: 'access' stamp: 'jjj 11/16/2011 19:38'!
units
		"Return the dimensions of Current"
		"This should be private or selectively exported to objects like Current."
	^unitsImp! !


!DimensionedRational methodsFor: 'as yet unclassified' stamp: 'jjj 11/16/2011 20:09'!
isDimensionedRational
		"Is Current a DimensionedRational?"
	^true! !


Object subclass: #Tester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'cs655'!

!Tester methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 20:56'!
testComplexConversions
	"Test the conversion operations of the DimensionedRational class where
	the units are composed of several dimensions and differing units"
	| cons kg m s lb ft min force accel newton |
	cons := Constants new.
	kg := DimensionedRational new makeBasic: cons kilogram.
	m := DimensionedRational new makeBasic: cons meter.
	s := DimensionedRational new makeBasic: cons second.
	lb := DimensionedRational new makeBasic: cons pound.
	ft := DimensionedRational new makeBasic: cons foot.
	min := DimensionedRational new makeBasic: cons minute.
	accel := ft / (min * min).
	force := lb * accel.
	newton := kg * m / (s * s).
	Transcript show: 'Begin complex conversion tests'.  Transcript cr.
	Transcript show: '          We have the same problem here as in testConversions (deepCopy on ',
		'Dictionary is broken.)  I could have performed the calculations until after this print statement, ',
		'but that would just mask the problem.  The correct output is included with the readme file'.
	Transcript cr.
	Transcript show: '    kg = '.  Transcript print: (kg).  Transcript cr.
	Transcript show: '    m = '.  Transcript print: (m). Transcript cr.
	Transcript show: '    s = '.  Transcript print: (s).  Transcript cr.
	Transcript show: '    min = '.  Transcript print: (min).  Transcript cr.
	Transcript show: '    lb = '.  Transcript print: (lb).  Transcript cr.
	Transcript show: '    ft = '.  Transcript print: (ft).  Transcript cr.
	Transcript show: '    accel = '.  Transcript print: (accel).  Transcript cr.
	Transcript show: '    force = '.  Transcript print: (force).  Transcript cr.
	Transcript show: '    newton = '.  Transcript print: (newton).  Transcript cr.
	Transcript show: '    lb / (min * min) converted: (lb / (s * s)) = '.  
		Transcript print: (lb / (min * min) converted: (lb / (s * s))).  Transcript cr.
	Transcript show: '    (ft * lb) converted: (kg * m) = '.  
		Transcript print: ((ft * lb) converted: (kg * m)).  Transcript cr.
	Transcript show: '    force converted: newton = '.  
		Transcript print: (force converted: newton).  Transcript cr.
	Transcript show: '    force converted: force = '.  
		Transcript print: (force converted: force).  Transcript cr.
	Transcript show: 'End complex conversion tests'.  Transcript cr.
! !

!Tester methodsFor: 'basic operations' stamp: 'jjj 11/17/2011 22:01'!
testConversions
	"Test the conversion operations of the DimensionedRational class"
	| cons m ft c k c28 f f212 mi kg lb|
	cons := Constants new make.
	m := DimensionedRational new makeBasic: cons meter.
	ft := DimensionedRational new makeBasic: cons foot.
	ft setN: 2 D:1.
	c := DimensionedRational new makeBasic: cons celcius.
	k := DimensionedRational new makeBasic: cons kelvin.
	f := DimensionedRational new makeBasic: cons fahrenheit.
	kg := DimensionedRational new makeBasic: cons kilogram.
	lb := DimensionedRational new makeBasic: cons pound.
	c28 := DimensionedRational new makeBasic: cons celcius.
	c28 setN: 28 D: 1.
	f212 := DimensionedRational new makeBasic: cons fahrenheit.
	f212 setN: 212 D: 1.
	mi := DimensionedRational new makeBasic: cons mile.
	Transcript show: 'Begin conversion tests'.  Transcript cr.
	Transcript show: '    m = '.  Transcript print: (m).  Transcript cr.
	Transcript show: '    ft = '.  Transcript print: (ft).  Transcript cr.
	Transcript show: '    c = '.  Transcript print: (c).  Transcript cr.
	Transcript show: '    k = '.  Transcript print: (k).  Transcript cr.
	Transcript show: '    c28 = '.  Transcript print: (c28).  Transcript cr.
	Transcript show: '    f212 = '.  Transcript print: (f212).  Transcript cr.
	Transcript show: '    mi = '.  Transcript print: (mi).  Transcript cr.
	Transcript show: '    kg = '.  Transcript print: (kg).  Transcript cr.
	Transcript show: '    lb = '.  Transcript print: (lb).  Transcript cr.
	Transcript show: '    m + ft = '.  Transcript print: (m + ft).  Transcript cr.
	Transcript show: '		GNU SmallTalk breaks at this point.  Notice that on the next ',
						'line the units of "ft" may have changed to meters.  In Squeak ',
						'SmallTalk, the system works as expected.  I suspect the problem ',
						'is with the way GNU impements deepCopy; it is causing the unit ',
						'names (contained in an objects that are placed into an array) to ',
						'become alliased.  I believe the arrays themselves are not actually ',
						'deepCopied.  I am not certain (or I would fix it), but I a google of ',
						'SmallTalk deepCopy leads me to this belief.' .
	Transcript cr.
	Transcript show: '    ft = '.  Transcript print: ft.  Transcript cr.
	Transcript show: '    mi = '.  Transcript print: mi.  Transcript cr.
	Transcript show: '    ft + mi = '.  Transcript print: (ft + mi).  Transcript cr.
	Transcript show: '     ft * mi = '.  Transcript print: (ft * mi).  Transcript cr.	
	Transcript show: '     mi * ft = '.  Transcript print: (mi * ft).  Transcript cr.
	Transcript show: '    c converted: k = '.  Transcript print: (c converted: k).  Transcript cr.
	Transcript show: '    c = '.  Transcript print: (c).  Transcript cr.	
	Transcript show: '    c28 converted: f = '.  Transcript print: (c28 converted: f).  Transcript cr.
	Transcript show: '    f212 converted: c = '.  Transcript print: (f212 converted: c).  Transcript cr.
	Transcript show: '    kg converted: lb = '.  Transcript print: (kg converted: lb).  Transcript cr.
	Transcript show: '    lb converted: kg = '.  Transcript print: (lb converted: kg).  Transcript cr.
	Transcript show: 'End conversion tests'.  Transcript cr.
! !

!Tester methodsFor: 'basic operations' stamp: 'jjj 11/17/2011 23:20'!
testDimensionedRationals
	"Test the Rational class"
	| cons ft m m2 s r |
	cons := Constants new make.
	ft := DimensionedRational new makeBasic: cons foot.
	m := DimensionedRational new makeBasic: cons meter.
	s := DimensionedRational new makeBasic: cons second.
	m setN: 60 D: 1.
	s setN: 50 D: 25.
	m2 := m + m.
	r := m / s.
	Transcript show: 'Begin test of DimensionedRational class'.  Transcript cr.
	Transcript show: '    ft = '.  Transcript print: ft.  Transcript cr.
	Transcript show: '    m = '.  Transcript print: m.  Transcript cr.
	Transcript show: '    s = '.  Transcript print: s.  Transcript cr.
	Transcript show: '    r = '.  Transcript print: r.  Transcript cr.
	Transcript show: '    m2 = '.  Transcript print: m2.  Transcript cr.
	Transcript show: '    m2 - m = '.  Transcript print: (m2 - m).  Transcript cr.
	Transcript show: '    r inverted = '.  Transcript print: r reciprocal.  Transcript cr.
	Transcript show: '    (m * s) inverted = '.  Transcript print: (m * s) reciprocal.  Transcript cr.
		"Test comparisons"
	Transcript show: '    m + ft = '.  Transcript print: (m + ft).  Transcript cr.
	Transcript show: '    ft + m = '.  Transcript print: (ft + m).  
	Transcript show: '  ERROR:  should be feet not meters.  (See comment in conversion tests.)'.  Transcript cr.
	Transcript show: '    m + ft = ft + m :   '.  Transcript print: ((m + ft) = (ft + m)).  Transcript cr.
	Transcript show: 'End test of DimensionedRational class'.  Transcript cr.
	! !

!Tester methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 18:24'!
testDimensions
		"Test the Dimensions class"
	| d t cons |
	cons := Constants new.
	d := Dimensionable new makeBasic: cons length.
	t := Dimensionable new makeBasic: cons time.
	Transcript show: 'Begin test of Dimension class'.  Transcript cr.
	Transcript show: '    d = '.  Transcript print: d.  Transcript cr.
	Transcript show: '    d + d = '.  Transcript print: (d + d).  Transcript cr.
	Transcript show: '    d - d = '.  Transcript print: (d - d).  Transcript cr.
	Transcript show: '    d * d = '.  Transcript print: (d * d).  Transcript cr.
	Transcript show: '    t = '.  Transcript print: t.  Transcript cr.
	Transcript show: '    d / t = '.  Transcript print: (d / t).  Transcript cr.
		" The line demonstrate the error expected 
		by adding incompatible dimensions."
"	Transcript show: '    d + t = '.  Transcript print: (d + t).  Transcript cr. "
	Transcript show:  'End test of Dimension class'.  Transcript cr.
	
	! !

!Tester methodsFor: 'basic operations' stamp: 'jjj 11/17/2011 22:55'!
testRationals
	"Test the Rational class"
	| r r2 r3 r4 |
	r := Rational new setN: 40 D: 20.
	r2 := Rational new setN: 4 D: 8.
	r3 := Rational new setN: 22 D: 7.
	r4 := r2 + r3.
	"r4 := r2 + 7."		"give error as expected"
		"The code below uses Transcript.  There were some problems with GST, so here 
		are some of the workarounds:
			I used streams in Squeak, but GST streams did not handle the long output.
			I had to use show with string or else the output had ticks around it.
			I had to use print in order to call printOn on the objects.
			GST could not understand sequencing as in Transcript show:  'a string' ;  cr.
		Hence the following code has calls to show and print and calls cr on Transcript."
	Transcript show: 'Begin test of Rational class'.  Transcript cr.
	Transcript show: '    r = '.  Transcript print: r.  Transcript cr.		
	Transcript show: '    r2 = '.  Transcript print: r2.  Transcript cr.
	Transcript show: '    r3 = '.  Transcript print: r3.  Transcript cr.
	Transcript show: '    r2 + r3 = '.  Transcript print: (r2 + r3).  Transcript cr.
	Transcript show: '    (r2+r3) isReduced = '.  Transcript print: (r2+r3) isReduced.  Transcript cr.
	Transcript show: '    r4 = '.  Transcript print: r4.  Transcript cr.
	Transcript show: '    r4 reciprocal = '.  Transcript print: r4 reciprocal.  Transcript cr.
	Transcript show: '    to verify deepCopy worked r4 still equals  '.  Transcript print: r4.  Transcript cr.
	Transcript show: '    r4 reciprocal - r3  = '.  Transcript print: (r4 reciprocal - r3).  Transcript cr.
	Transcript show: '    r4 * r2 negated = '.  Transcript print: (r4 * r2 negated).  Transcript cr.
	Transcript show: '    r4 / r2 = '.  Transcript print: (r4 / r2).  Transcript cr.
		"test comparisons"
	Transcript show: '    r2 < r4 :   '.  Transcript print: (r2 < r4).  Transcript cr.
	Transcript show: '    r4 < r2 :   '.  Transcript print: (r4 < r2).  Transcript cr.
	Transcript show: '    r < r2 :   '.  Transcript print: (r < r2).  Transcript cr.
	Transcript show: '    r = r2 :   '.  Transcript print: (r = r2).  Transcript cr.
	Transcript show: '    r <= r2 :   '.  Transcript print: (r <= r2).  Transcript cr.
	Transcript show: '    r >= r2 :   '.  Transcript print: (r >= r2).  Transcript cr.
	Transcript show: '    (r2 <= r2 reciprocal) :   '.  Transcript print: (r <= r2 reciprocal).  Transcript cr.
	Transcript show: '    (r2 = r2) '.  Transcript print: (r2 <= r2).  Transcript cr.
	Transcript show: '    (r2 * (r2 reciprocal)) = ((r2 reciprocal) * r2) :   '.  
				Transcript print: (r2 * (r2 reciprocal)) = ((r2 reciprocal) * r2) .  Transcript cr.
		"The following line is not allowed by precondition"
"	Transcript show: '    r < 5 :   '.  Transcript print: (r <= 5).  Transcript cr."
				
	Transcript show: 'End test of Rational class'.  Transcript cr.
	! !


!Tester methodsFor: 'initialize-release' stamp: 'jjj 11/17/2011 21:50'!
make
		"Simply run some tests"
	self testRationals.
	self testDimensions.
	self testDimensionedRationals.
	self testConversions.
	self testComplexConversions.! !


Object subclass: #Unit
	instanceVariableNames: 'nameImp typeImp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'cs655'!

!Unit methodsFor: 'as yet unclassified' stamp: 'jjj 11/16/2011 16:39'!
make: aName Type: aType
	nameImp := aName.
	typeImp := aType.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'jjj 11/11/2011 21:10'!
name
	^nameImp! !

!Unit methodsFor: 'as yet unclassified' stamp: 'jjj 11/14/2011 00:00'!
printOn: aStream
	aStream
		print: nameImp; cr;
		print: typeImp.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'jjj 11/11/2011 21:10'!
type
	^typeImp! !


Dimensionable subclass: #Unitable
	instanceVariableNames: 'unitsImp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'cs655'!

!Unitable methodsFor: 'query' stamp: 'jjj 11/16/2011 18:44'!
dimensionString: index
		"The string representation of the index-th unit.  This redefines the version
		from Dimensionable to return the unit instead of the dimension."
	^(self unitString: index)! !

!Unitable methodsFor: 'query' stamp: 'jjj 11/17/2011 19:28'!
unitAt: index
		"The i-th unit of Current"
	^(unitsImp at: index)! !

!Unitable methodsFor: 'query' stamp: 'jjj 11/16/2011 17:43'!
unitString: index
		"The name of the unit at index in units"
	^((unitsImp at: index) name)! !


!Unitable methodsFor: 'initialize-release' stamp: 'jjj 11/17/2011 21:49'!
make
		"Initialize as unitless"
	super make.
	unitsImp := Array new: (self amount).
	self length to: (self amount) do: [ :index | unitsImp at: index put: nil ].! !

!Unitable methodsFor: 'initialize-release' stamp: 'jjj 11/16/2011 19:01'!
makeBasic: aUnit
		"Initialize Current as a basic dimension, representing a unit."
	(aUnit ~= nil) ifFalse: [^ self error: 'aUnit exists'].
	super makeBasic: (aUnit type).
	unitsImp at: (aUnit type) put: aUnit.! !


!Unitable methodsFor: 'access' stamp: 'jjj 11/17/2011 21:06'!
units
		"Get the units array.  This should be exported only to objects like Current."
	^unitsImp! !


!Unitable methodsFor: 'basic operations' stamp: 'jjj 11/17/2011 20:34'!
convert: other
		"Make Current have same units as other."
	| cons u u2 |
	cons := Constants new.
	cons length to: cons amount do: [ :index |
		( ((self unitAt: index) ~= nil)  & ((other unitAt: index) ~= nil)) ifTrue:
"			[unitsImp at: index put: (other unitAt: index)]]
"	
"			[u := (other unitAt: index) deepCopy.
			unitsImp at: index put: u]]
"
			[u := other unitAt: index.
			u2 := Unit new make: u name deepCopy Type: u type.
			unitsImp at: index put: u2]]
! !

!Unitable methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 17:45'!
converted: other
		"Result of converting Current to other"
	^(self deepCopy convert: other)! !

!Unitable methodsFor: 'basic operations' stamp: 'jjj 11/16/2011 20:10'!
multiply: other
		"Multiply Current by other"
	super multiply: other.
	self length to: self amount do: [ :index |
			"ensure there are no units for zeroed-out dimensions
			OTOH, ensure there is a unit ... but don't change it if one is already present."
		((dimensionsImp at: index) = 0) 
			ifTrue: [unitsImp at: index put: nil]
			ifFalse: [((unitsImp at: index) = nil) ifTrue: [unitsImp at: index put: (other unitAt: index)]]]! !
